package com.ruoyi.system.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import javax.validation.Validator;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.common.constant.AppLoginEnum;
import com.ruoyi.common.constant.AppUserTypeEnum;
import com.ruoyi.common.constant.DeletedEnum;
import com.ruoyi.common.core.domain.AppLoginBaseEntity;
import com.ruoyi.common.core.domain.entity.MySysPost;
import com.ruoyi.common.core.domain.entity.TbSysAreaUser;
import com.ruoyi.common.core.domain.model.SysUserSimple;
import com.ruoyi.common.exception.base.BaseException;
import com.ruoyi.system.domain.AppLogin;
import com.ruoyi.system.service.IAppLoginService;
import com.ruoyi.system.service.IContractorUserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.util.CollectionUtils;
import com.ruoyi.common.annotation.DataScope;
import com.ruoyi.common.constant.UserConstants;
import com.ruoyi.common.core.domain.entity.SysRole;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.bean.BeanValidators;
import com.ruoyi.common.utils.spring.SpringUtils;
import com.ruoyi.system.domain.SysPost;
import com.ruoyi.system.domain.SysUserPost;
import com.ruoyi.system.domain.SysUserRole;
import com.ruoyi.system.mapper.SysPostMapper;
import com.ruoyi.system.mapper.SysRoleMapper;
import com.ruoyi.system.mapper.SysUserMapper;
import com.ruoyi.system.mapper.SysUserPostMapper;
import com.ruoyi.system.mapper.SysUserRoleMapper;
import com.ruoyi.system.service.ISysConfigService;
import com.ruoyi.system.service.ISysUserService;

/**
 * 用户 业务层处理
 *
 * @author ruoyi
 */
@Service
public class SysUserServiceImpl implements ISysUserService {
    private static final Logger log = LoggerFactory.getLogger(SysUserServiceImpl.class);
    @Autowired
    private SysUserMapper userMapper;
    @Autowired
    private SysRoleMapper roleMapper;
    @Autowired
    private SysPostMapper postMapper;
    @Autowired
    private SysUserRoleMapper userRoleMapper;
    @Autowired
    private SysUserPostMapper userPostMapper;
    @Autowired
    private ISysConfigService configService;
    @Autowired
    protected Validator validator;
//    @Autowired
//    protected IContractorUserService contractorUserService;
    @Autowired
    private IAppLoginService appLoginService;

    /**
     * 根据条件分页查询用户列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectUserList(SysUser user) {
        return userMapper.selectUserList(user);
    }

    @Override
    public List<SysUserSimple> selectAllUserList() {
        return userMapper.selectAllUserList();
    }

    /**
     * 根据条件分页查询已分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectAllocatedList(SysUser user) {
        return userMapper.selectAllocatedList(user);
    }

    /**
     * 根据条件分页查询未分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectUnallocatedList(SysUser user) {
        return userMapper.selectUnallocatedList(user);
    }

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserByUserName(String userName) {
        return userMapper.selectUserByUserName(userName);
    }

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserById(Long userId) {
        return userMapper.selectUserById(userId);
    }

    /**
     * 查询用户所属角色组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserRoleGroup(String userName) {
        List<SysRole> list = roleMapper.selectRolesByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysRole::getRoleName).collect(Collectors.joining(","));
    }

    /**
     * 查询用户所属岗位组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserPostGroup(String userName) {
        List<SysPost> list = postMapper.selectPostsByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysPost::getPostName).collect(Collectors.joining(","));
    }

    /**
     * 校验用户名称是否唯一
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public boolean checkUserNameUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkUserNameUnique(user.getUserName());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验手机号码是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public boolean checkPhoneUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkPhoneUnique(user.getPhonenumber());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验email是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public boolean checkEmailUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkEmailUnique(user.getEmail());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验用户是否允许操作
     *
     * @param user 用户信息
     */
    @Override
    public void checkUserAllowed(SysUser user) {
        if (StringUtils.isNotNull(user.getUserId()) && user.isAdmin()) {
            throw new ServiceException("不允许操作超级管理员用户");
        }
    }

    /**
     * 校验用户是否有数据权限
     *
     * @param userId 用户id
     */
    @Override
    public void checkUserDataScope(Long userId) {
        if (!SysUser.isAdmin(SecurityUtils.getUserId())) {
            SysUser user = new SysUser();
            user.setUserId(userId);
            List<SysUser> users = SpringUtils.getAopProxy(this).selectUserList(user);
            if (StringUtils.isEmpty(users)) {
                throw new ServiceException("没有权限访问用户数据！");
            }
        }
    }

    /**
     * 新增保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertUser(SysUser user) {
        // 新增用户信息
        int rows = userMapper.insertUser(user);
        // 新增用户岗位关联
        insertUserPost(user);
        // 新增用户与角色管理
        insertUserRole(user);

        //判断是否创建APP账号
        if (AppLoginEnum.YES.getValue().equals(user.getLoginApp())) {
            //1、判断APP用户表是否已存在userId
            Long userId = user.getUserId();
            LambdaQueryWrapper<AppLogin> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(AppLogin::getUserId, userId);
            lambdaQueryWrapper.eq(AppLogin::getIsDel, DeletedEnum.VALID.getValue());
            List<AppLogin> appLoginList = appLoginService.list(lambdaQueryWrapper);
            if (!CollectionUtils.isEmpty(appLoginList)) {
                List<Long> idList = appLoginList.stream().map(AppLogin::getId).collect(Collectors.toList());
                List<String> userNameList = appLoginList.stream().map(AppLogin::getUserName).collect(Collectors.toList());
                //设置手动回滚
                //TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                //改为抛异常回滚
                throw new BaseException("APP用户表存在相同的用户ID！【" + idList + "】+【" + userNameList + "】");
            }

            //1、判断APP用户表是否已存在userName
            String userName = user.getUserName();
            lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(AppLogin::getUserName, userName);
            lambdaQueryWrapper.eq(AppLogin::getIsDel, DeletedEnum.VALID.getValue());
            appLoginList = appLoginService.list(lambdaQueryWrapper);
            if (!CollectionUtils.isEmpty(appLoginList)) {
                List<Long> idList = appLoginList.stream().map(AppLogin::getId).collect(Collectors.toList());
                List<String> userNameList = appLoginList.stream().map(AppLogin::getUserName).collect(Collectors.toList());
                //设置手动回滚
                //TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                //改为抛异常回滚
                throw new BaseException("APP用户表存在相同的用户名！【" + idList + "】+【" + userNameList + "】");
            }

            //插入APP用户
            AppLoginBaseEntity appLogin = new AppLoginBaseEntity();
            appLogin.setId(System.currentTimeMillis());
            appLogin.setUserName(user.getUserName());
            appLogin.setPassword(user.getPassword());
            appLogin.setUserId(user.getUserId());
            appLogin.setUserType(AppUserTypeEnum.USER.getValue());
            appLogin.setCreateDefault();
            userMapper.insertAppLogin(appLogin);
        }

        return rows;
    }

    /**
     * 注册用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public boolean registerUser(SysUser user) {
        return userMapper.insertUser(user) > 0;
    }

    /**
     * 修改保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int updateUser(SysUser user) {
        Long userId = user.getUserId();
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 新增用户与角色管理
        insertUserRole(user);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPostByUserId(userId);
        // 新增用户与岗位管理
        insertUserPost(user);


        //查询APP用户是否已存在
        AppLoginBaseEntity appLoginParam = new AppLoginBaseEntity();
        appLoginParam.setUserId(userId);
        List<AppLoginBaseEntity> appLoginList = userMapper.selectAppLogin(appLoginParam);

        //判断是否创建APP账号
        if (AppLoginEnum.YES.getValue().equals(user.getLoginApp())) {
            //插入
            if (CollectionUtils.isEmpty(appLoginList)) {
                AppLoginBaseEntity appLogin = new AppLoginBaseEntity();
                appLogin.setId(System.currentTimeMillis());
                appLogin.setUserName(user.getUserName());
                appLogin.setPassword(user.getPassword());
                appLogin.setUserId(user.getUserId());
                appLogin.setUserType(AppUserTypeEnum.USER.getValue());
                appLogin.setCreateDefault();
                userMapper.insertAppLogin(appLogin);
            }
            //更新
            else {
                //判断是否是删除状态，如果是删除则改成有效
                if (appLoginList.get(0).getIsDel().equals(DeletedEnum.INVALID.getValue())) {
                    AppLoginBaseEntity appLogin = new AppLoginBaseEntity();
//                    appLogin.setId(appLoginList.get(0).getId());
                    appLogin.setUserId(userId);
                    appLogin.setIsDel(DeletedEnum.VALID.getValue());
                    appLogin.setUpdateDefault();
                    userMapper.updateAppLogin(appLogin);
                }

            }
        } else {
            if (!CollectionUtils.isEmpty(appLoginList) && appLoginList.get(0).getIsDel().equals(DeletedEnum.VALID.getValue())) {
                AppLoginBaseEntity appLogin = new AppLoginBaseEntity();
//                appLogin.setId(appLoginList.get(0).getId());
                appLogin.setUserId(userId);
                appLogin.setIsDel(DeletedEnum.INVALID.getValue());
                appLogin.setUpdateDefault();
                userMapper.updateAppLogin(appLogin);
            }
        }

        return userMapper.updateUser(user);
    }

    /**
     * 用户授权角色
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    @Override
    @Transactional
    public void insertUserAuth(Long userId, Long[] roleIds) {
        userRoleMapper.deleteUserRoleByUserId(userId);
        insertUserRole(userId, roleIds);
    }

    /**
     * 修改用户状态
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserStatus(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户基本信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserProfile(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户头像
     *
     * @param userName 用户名
     * @param avatar   头像地址
     * @return 结果
     */
    @Override
    public boolean updateUserAvatar(String userName, String avatar) {
        return userMapper.updateUserAvatar(userName, avatar) > 0;
    }

    /**
     * 重置用户密码
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int resetPwd(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    @Override
    public int resetUserPwd(String userName, String password) {
        return userMapper.resetUserPwd(userName, password);
    }

    /**
     * 新增用户角色信息
     *
     * @param user 用户对象
     */
    public void insertUserRole(SysUser user) {
        this.insertUserRole(user.getUserId(), user.getRoleIds());
    }

    /**
     * 新增用户岗位信息
     *
     * @param user 用户对象
     */
    public void insertUserPost(SysUser user) {
        Long[] posts = user.getPostIds();
        if (StringUtils.isNotEmpty(posts)) {
            // 新增用户与岗位管理
            List<SysUserPost> list = new ArrayList<SysUserPost>(posts.length);
            for (Long postId : posts) {
                SysUserPost up = new SysUserPost();
                up.setUserId(user.getUserId());
                up.setPostId(postId);
                list.add(up);
            }
            userPostMapper.batchUserPost(list);
        }
    }

    /**
     * 新增用户角色信息
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    public void insertUserRole(Long userId, Long[] roleIds) {
        if (StringUtils.isNotEmpty(roleIds)) {
            // 新增用户与角色管理
            List<SysUserRole> list = new ArrayList<SysUserRole>(roleIds.length);
            for (Long roleId : roleIds) {
                SysUserRole ur = new SysUserRole();
                ur.setUserId(userId);
                ur.setRoleId(roleId);
                list.add(ur);
            }
            userRoleMapper.batchUserRole(list);
        }
    }

    /**
     * 通过用户ID删除用户
     *
     * @param userId 用户ID
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteUserById(Long userId) {
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 删除用户与岗位表
        userPostMapper.deleteUserPostByUserId(userId);
        return userMapper.deleteUserById(userId);
    }

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteUserByIds(Long[] userIds) {
        for (Long userId : userIds) {
            checkUserAllowed(new SysUser(userId));
            checkUserDataScope(userId);
        }
        // 删除用户与角色关联
        userRoleMapper.deleteUserRole(userIds);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPost(userIds);
        //删除承包商用户表
        String[] appUserIdArr = new String[userIds.length];
        for (int i = 0; i < userIds.length; i++) {
            appUserIdArr[i] = String.valueOf(userIds[i]);
        }
        appLoginService.deleteAppLoginByIds(appUserIdArr);

        return userMapper.deleteUserByIds(userIds);
    }

    /**
     * 导入用户数据
     *
     * @param userList        用户数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param operName        操作用户
     * @return 结果
     */
    @Override
    public String importUser(List<SysUser> userList, Boolean isUpdateSupport, String operName) {
        if (StringUtils.isNull(userList) || userList.size() == 0) {
            throw new ServiceException("导入用户数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        String password = configService.selectConfigByKey("sys.user.initPassword");
        for (SysUser user : userList) {
            try {
                // 验证是否存在这个用户
                SysUser u = userMapper.selectUserByUserName(user.getUserName());
                if (StringUtils.isNull(u)) {
                    BeanValidators.validateWithException(validator, user);
                    user.setPassword(SecurityUtils.encryptPassword(password));
                    user.setCreateBy(operName);
                    userMapper.insertUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 导入成功");
                } else if (isUpdateSupport) {
                    BeanValidators.validateWithException(validator, user);
                    checkUserAllowed(u);
                    checkUserDataScope(u.getUserId());
                    user.setUserId(u.getUserId());
                    user.setUpdateBy(operName);
                    userMapper.updateUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、账号 " + user.getUserName() + " 已存在");
                }
            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、账号 " + user.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }

    /**
     * 通过ID列表查询用户信息
     *
     * @param ids
     * @return
     */
    @Override
    public List<SysUser> selectUserByIds(List<Long> ids) {
        return userMapper.selectUserByIds(ids);
    }

    /**
     * 根据岗位查询人员信息
     *
     * @param postIdList
     * @return
     */
    @Override
    public List<SysUser> selectUserByPostIds(List<Long> postIdList) {
        return userMapper.selectUserByPostIds(postIdList);
    }

    /**
     * 统计企业人数
     *
     * @param companyCode 企业编码
     * @return
     */
    @Override
    public Integer selectUserCount(String companyCode) {
        return userMapper.selectUserCount(companyCode);
    }

    /**
     * 获取用户列表：级联查询用户岗位中间表和部门表
     *
     * @param user
     * @return
     */
    @Override
    public List<SysUser> selectUserListInnerDeptPost(SysUser user) {
        List<SysUser> sysUserList = userMapper.selectUserDeptList(user);

        Set<Long> userIdSet = sysUserList.stream().map(SysUser::getUserId).collect(Collectors.toSet());

        List<MySysPost> postList = userMapper.selectUserPostList(userIdSet);
        Map<Long, List<MySysPost>> userPostListMap = postList.stream().collect(Collectors.groupingBy(MySysPost::getUserId));

        for (SysUser sysUser : sysUserList) {
            sysUser.setPostList(userPostListMap.get(sysUser.getUserId()));
        }

        return sysUserList;
    }
}
